SoReorganizeAction(3)

NAME
SoReorganizeAction - The SoReorganizeAction class reorganizes your scene graph to optimize traversal/rendering.

SYNOPSIS

#include <Inventor/actions/SoReorganizeAction.h>

Inherits SoSimplifyAction.

  Public Member Functions
virtual SoType getTypeId (void) const
SoReorganizeAction (SoSimplifier *simplifier=NULL)
virtual ~SoReorganizeAction (void)
SoSeparator * getSimplifiedSceneGraph (void) const
void generateNormals (SbBool onoff)
SbBool areNormalGenerated (void) const
void generateTriangleStrips (SbBool onoff)
SbBool areTriangleStripGenerated (void) const
void generateTexCoords (SbBool onoff)
SbBool areTexCoordsGenerated (void) const
void generateVPNodes (SbBool onoff)
SbBool areVPNodesGenerated (void)
void matchIndexArrays (SbBool onoff)
SbBool areIndexArraysMatched (void) const
SoSimplifier * getSimplifier (void) const
virtual void apply (SoNode *root)
virtual void apply (SoPath *path)
virtual void apply (const SoPathList &pathlist, SbBool obeysrules=FALSE)

  Static Public Member Functions
static SoType getClassTypeId (void)
static void addMethod (const SoType type, SoActionMethod method)
static void enableElement (const SoType type, const int stackindex)
static void initClass (void)
static void startReport (const char *msg)
static void finishReport (void)

  Protected Member Functions
virtual const SoEnabledElementsList & getEnabledElements (void) const
virtual void beginTraversal (SoNode *node)

  Static Protected Member Functions
static SoEnabledElementsList * getClassEnabledElements (void)
static SoActionMethodList * getClassActionMethods (void)

  Additional Inherited Members

Detailed Description

The SoReorganizeAction class reorganizes your scene graph to optimize traversal/rendering. Note. This is work-in-progress. pederb, 2005-04-05.

The code below is an example of a program that applies an SoReorganizeAction on a scene graph, converting all shapes into shapes that can be rendered using vertex array or VBO rendering.

#include <Inventor/SoDB.h>
#include <Inventor/nodes/SoSeparator.h>
#include <Inventor/nodes/SoCoordinate3.h>
#include <Inventor/nodes/SoCoordinate4.h>
#include <Inventor/nodes/SoNormal.h>
#include <Inventor/nodes/SoTextureCoordinate2.h>
#include <Inventor/nodes/SoSeparator.h>
#include <Inventor/actions/SoWriteAction.h>
#include <Inventor/actions/SoSearchAction.h>
#include <Inventor/errors/SoDebugError.h>
#include <Inventor/nodes/SoShapeHints.h>
#include <Inventor/SoInput.h>
#include <Inventor/SoOutput.h>
#include <Inventor/SoInteraction.h>
#include <Inventor/actions/SoReorganizeAction.h>
#include <cassert>
#include <cstdio>
static void strip_node(SoType type, SoNode * root)
{
  SoSearchAction sa;
  sa.setType(type);
  sa.setSearchingAll(TRUE);
  sa.setInterest(SoSearchAction::ALL);
  sa.apply(root);
  SoPathList & pl = sa.getPaths();
  for (int i = 0; i < pl.getLength(); i++) {
    SoFullPath * p = (SoFullPath*) pl[i];
      if (p->getTail()->isOfType(type)) {
        SoGroup * g = (SoGroup*) p->getNodeFromTail(1);
        g->removeChild(p->getIndexFromTail(0));
      }
    }
  sa.reset();
}
int
main(int argc, char ** argv )
{
  if (argc < 3) {
    fprintf(stderr,"Usage: reorganize <infile> <outfile> [nostrip]);
    return -1;
  }
  SbBool strip = TRUE;
  if (argc > 3) {
    if (strcmp(argv[3], "nostrip") == 0) strip = FALSE;
    else {
      fprintf(stderr,"Usage: reorganize <infile> <outfile> [nostrip]);
      return -1;
    }
  }
  SoDB::init();
  SoInteraction::init();
  SoInput input;
  SbBool ok = input.openFile(argv[1]);
  if (!ok) {
    fprintf(stderr,"Unable to open file.);
    return -1;
  }
  SoSeparator * root = SoDB::readAll(&input);
  SbBool vrml1 = input.isFileVRML1();
  SbBool vrml2 = input.isFileVRML2();
  if (vrml2) {
    fprintf(stderr,"VRML2 not supported yet);
    return -1;
  }
  if (!root) {
    fprintf(stderr,"Unable to read file.);
    return -1;
  }
  root->ref();
  fprintf(stderr,"Applying SoReorganizeAction...");
  SoReorganizeAction reorg;
  reorg.apply(root);
  fprintf(stderr,"done);
  SoOutput out;
  if (out.openFile(argv[2])) {
    if (strip) { // strip coord3, texcoord and normal nodes
      fprintf(stderr,"stripping old nodes from scene graph);
      strip_node(SoCoordinate3::getClassTypeId(), root);
      strip_node(SoCoordinate4::getClassTypeId(), root);
      strip_node(SoNormal::getClassTypeId(), root);
      strip_node(SoTextureCoordinate2::getClassTypeId(), root);
    }
    fprintf(stderr,"writing target);
    SoWriteAction wa(&out);
    wa.apply(root);
  }
  root->unref();
  return 0;
} // main()

Since
    Coin 2.5

Constructor & Destructor Documentation

  SoReorganizeAction::SoReorganizeAction (SoSimplifier * simplifier = NULL)
A constructor.

  SoReorganizeAction::~SoReorganizeAction (void) [virtual]
The destructor.

Member Function Documentation

  SoType SoReorganizeAction::getTypeId (void) const [virtual]
Returns the type identification of an object derived from a class inheriting SoAction. This is used for runtime type checking and 'downward' casting.

Reimplemented from SoSimplifyAction.

  SoType SoReorganizeAction::getClassTypeId (void) [static]
This static method returns the SoType object associated with objects of this class.

  void SoReorganizeAction::addMethod (const SoType type, SoActionMethod method) [static]
This API member is considered internal to the library, as it is not likely to be of interest to the application programmer.

  void SoReorganizeAction::enableElement (const SoType type, const int stackindex) [static]
This API member is considered internal to the library, as it is not likely to be of interest to the application programmer.

  const SoEnabledElementsList & SoReorganizeAction::getEnabledElements (void) const [protected], [virtual]
Returns list of enabled elements.

Reimplemented from SoSimplifyAction.

  SoEnabledElementsList * SoReorganizeAction::getClassEnabledElements (void) [static], [protected]
Returns list of enabled elements for this class. The enabledElements and methods variables are protected in the original OIV API. This is not such a good idea, since exposed static class member variables is a major grievance with regard to Win32 DLLs. This function is an extension for Coin, and it is not available in the original SGI Open Inventor v2.1 API.

  SoActionMethodList * SoReorganizeAction::getClassActionMethods (void) [static], [protected]
Returns list of action methods for this class. The enabledElements and methods variables are protected in the original OIV API. This is not such a good idea, since exposed static class member variables is a major grievance with regard to Win32 DLLs. This function is an extension for Coin, and it is not available in the original SGI Open Inventor v2.1 API.

  void SoReorganizeAction::initClass (void) [static]
Initializes the runtime type system for this class, and sets up the enabled elements and action method list.

  void SoReorganizeAction::apply (SoNode * root) [virtual]
Applies the action to the scene graph rooted at root.

Note that you should not apply an action to a node with a zero reference count. The behavior in that case is undefined.

Reimplemented from SoSimplifyAction.

  void SoReorganizeAction::apply (SoPath * path) [virtual]
Applies the action to the parts of the graph defined by path.

Note that an SoPath will also contain all nodes that may influence e.g. geometry nodes in the path. So for instance applying an SoGLRenderAction on an SoPath will render that path as expected in the view, where geometry will get its materials, textures, and other appearance settings correctly.

If the path ends in an SoGroup node, the action will also traverse the tail node's children.

Reimplemented from SoSimplifyAction.

  void SoReorganizeAction::apply (const SoPathList & pathlist, SbBool obeysrules = FALSE) [virtual]
Applies action to the graphs defined by pathlist. If obeysrules is set to TRUE, pathlist must obey the following four conditions (which is the case for path lists returned from search actions for non-group nodes and path lists returned from picking actions):

All paths must start at the same head node. All paths must be sorted in traversal order. The paths must be unique. No path can continue through the end point of another path.

See also
    SoAction::apply(SoPath * path)

Reimplemented from SoSimplifyAction.

  void SoReorganizeAction::beginTraversal (SoNode * node) [protected], [virtual]
This virtual method is called from SoAction::apply(), and is the entry point for the actual scene graph traversal.

It can be overridden to initialize the action at traversal start, for specific initializations in the action subclasses inheriting SoAction.

Default method just calls traverse(), which any overridden implementation of the method must do too (or call SoAction::beginTraversal()) to trigger the scene graph traversal.

Reimplemented from SoSimplifyAction.

Author

Generated automatically by Doxygen for Coin from the source code.